<template>
  <v-card id="submission-type">
    <v-toolbar>
      <span class="title">{{ name }} - Full score: {{ fullScore }}</span>
      <v-spacer />
      <v-btn
        v-if="closeable"
        icon
        @click="close"
      >
        <v-icon>close</v-icon>
      </v-btn>
    </v-toolbar>
    <v-expansion-panels
      v-model="expanded"
      multiple
      accordion
    >
      <v-expansion-panel
        v-for="(item, i) in typeItems"
        :key="i"
      >
        <v-expansion-panel-header>
          <b>{{ item.title }}</b>
          <v-btn
            v-if="item.title == 'Solution'"
            color="info"
            text
            @click.stop="showSolutionComments = !showSolutionComments"
          >
            Toggle Comments
          </v-btn>
        </v-expansion-panel-header>
        <v-expansion-panel-content
          v-if="item.title === 'Description'"
          class="type-description"
        >
          <math-renderer>
            <!-- eslint-disable-next-line -->
            <div class="description-content" v-html="item.text" />
          </math-renderer>
        </v-expansion-panel-content>
        <v-expansion-panel-content v-else-if="item.title === 'Solution'">
          <solution
            :pk="pk"
            :solution="solution"
            :programming-language="programmingLanguage"
            :solution-comments="solutionComments"
            :show-solution-comments="showSolutionComments"
            :editable="allowEditSolutionComments"
          />
        </v-expansion-panel-content>
      </v-expansion-panel>
    </v-expansion-panels>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop, Watch } from 'vue-property-decorator'
import { highlight } from 'highlight.js'
import { UI } from '@/store/modules/ui'
import { SolutionComment } from '../../models'
import Solution from '@/components/submission_type/solution/Solution.vue'
import { Authentication } from '@/store/modules/authentication'
import MathRenderer from '@/components/MathRenderer.vue'

@Component({
  components: { Solution, MathRenderer }
})
export default class SubmissionType extends Vue {
  @Prop({
    type: String,
    required: true,
  }) pk!: string
  @Prop({
    type: String,
    required: true
  }) name!: string
  @Prop({
    type: String,
    required: true
  }) description!: string
  @Prop({
    type: String,
    required: false,
    default: ''
  }) solution!: string
  @Prop({
    type: Number,
    required: true
  }) fullScore!: number
  @Prop({
    type: String,
    default: 'c'
  }) programmingLanguage!: string
  @Prop({
    type: Boolean,
    default: false
  }) reverse!: boolean
  @Prop({
    type: Object,
    default: () => {return {}},
  }) solutionComments!: {[ofLine: number]: SolutionComment[]}
  @Prop({
    type: Object,
    default: function () {
      return {
        Description: true,
        Solution: true
      }
    }
  }) expandedByDefault!: {Description: boolean, Solution: boolean}
  @Prop({
    type: Boolean,
    default: true
  }) closeable!: boolean

  expanded = [
    ...(this.expandedByDefault.Description ? [this.reverse ? 0 : 1] : []),
    ...(this.expandedByDefault.Solution ? [this.reverse ? 1 : 0] : [])
  ]

  showSolutionComments = true

  get allowEditSolutionComments () {
    return Authentication.isTutorOrReviewer
  }

  get typeItems () {
    let items = [
      {
        title: 'Description',
        text: this.description
      }
    ]
    if (this.solution) {
      items.push({
        title: 'Solution',
        text: this.solution
      })
    }
    if (this.reverse) {
      return items.reverse()
    } else {
      return items
    }
  }
  get highlightedSolution () {
    return highlight(this.programmingLanguage, this.solution, true).value
  }

  close() {
    UI.SET_SHOW_SUBMISSIONTYPE(false)
  }

  mounted () {
    window.MathJax.typeset()
  }
}
</script>

<style>
  .description-content pre {
    overflow-x: auto;
  }

  .v-expansion-panel {
    /* Vuetify limits the height by default. We don't want that.*/
    max-height: initial;
  }
</style>

